const event = exports.event = require('../event');

class Device {
	constructor () {

	}
}

class DeviceUnit extends Device {

}

class Button {
	constructor({down = Button.noop, up = Button.noop}) {
		this.holding = false;
		this.downTime = 0;
		this.downFn = down;
		this.upFn = up;
	}

	down() {
		return Promise.resolve().then(() => {
			return this.holding && this.up();
		}).then(() => {
			return this.downFn();
		}).then(() => {
			this.holding = true;
			this.downTime = Date.now();
		});
	}

	$checkReleased() {
		return Promise.resolve().then(() => {
			if (!this.holding) {
				throw new Error('The button has been released.');
			}
			this.holding = false;
		});
	}

	$stdOut(err) {
		/*eslint-disable no-console */
		console.warn(err.message);
		/*eslint-enable no-console */
		throw err;
	}

	up() {
		return this.$checkReleased().then(() => this.upFn(), this.$stdOut);
	}

	static noop() {}
}

exports.Device = Device;
exports.DeviceUnit = DeviceUnit;
exports.Button = Button;