const {Device} = require('../device');
const pointer = require('./pointer');
const button = require('./button');

module.exports = Object.assign(new Device(), {
	pointTo({clientX, clientY}) {
		return pointer.moveTo({clientX, clientY}, true);
	},
	moveTo({clientX, clientY}) {
		return pointer.moveTo({clientX, clientY});
	},
	holdButton(name = 'left') {
		return button.hold(name);
	},
	releaseButton(name = 'left') {
		return button.release(name);
	},
	clickButton(name = 'left') {
		return Promise.resolve()
			.then(() => this.holdButton(name))
			.then(() => this.releaseButton(name));
	},
	release() {
		button.releaseAll();
	},
	init(position = pointer.position, callback) {
		//TODO check arguments.
		return this.pointTo(position).then(callback);
	}
});