function visitFrameWindow(window) {
	try {
		if (!window) {
			return [];
		}
		window.document;
	} catch(err) {
		return [];
	}

	let windowList = [window];
	Array.from(window.document && window.document.querySelectorAll('iframe'))
		.forEach(iframe => {
			const iframeWindow = iframe.contentWindow;
			windowList = windowList.concat(visitFrameWindow(iframeWindow));
		});
	
	return windowList;
}

function traverseFrame(rootWindow, callback = () => {}) {
	visitFrameWindow(rootWindow).forEach(window => {
		callback(window);
	});
}

exports.traverseFrame = traverseFrame;
exports.animate = require('./animate');
exports.element = require('./element');
exports.$ = require('./selector');