const $ = require('lc2-selector')(require('sizzle'));
const {xpath2css, isXPath} = require('lc-xpath');
const {runByEval} = require('./eval');
const state = require('../state');

module.exports = function (selector, context) {
	if(typeof selector === 'string') {
		selector = selector.trim();
	} else {
		state.error('selector', new Error('Selector must be a string.'));
	}
	try {
		if(/^JS:[\s\S]+/.test(selector)) {
			const code = selector.replace('JS:', '');
			return runByEval(code);
		} else if (isXPath(selector.split('<')[0])) {
			const resolved = selector.split('<');
			resolved.forEach((xpath, index) => {
				resolved[index] = xpath2css(xpath);
			});
			selector = resolved.join('<');
		}
		return $(selector, context);
	} catch (err) {
		state.error('selector', err);
		return [];
	}
};