const HtmlWebpackPlugin = require('html-webpack-plugin');

function sort(a, b) {
	if (a.names[0] < b.names[0]) {
		return -1;
	}

	return 1;
}

module.exports = [
	{
		devtool: 'source-map',
		entry: {
			driver: './index.js',
			test: './test/index.js'
		},
		output: {
			filename: '[name].es6.js',
			library: '__LC_DRIVER__',
			libraryTarget: 'umd'
		},
		module: {
			loaders: [
				{
					test: /\.css$/,
					loader: 'style-loader!css-loader'
				}
			]
		},
		plugins: [
			new HtmlWebpackPlugin({
				template: './test/index.html',
				filename: 'index.es6.html',
			})
		]
	},
	{
		devtool: 'source-map',
		entry: {
			core: 'core-js/shim',
			driver: './index.js',
			test: './test/index.js'
		},
		output: {
			filename: '[name].es5.js',
			library: '__LC_DRIVER__',
			libraryTarget: 'umd'
		},
		module: {
			loaders: [
				{
					test: /\.js$/,
					exclude: /node_modules\S+(lodash|core-js)/,
					loader: 'babel-loader'
				},
				{
					test: /\.css$/,
					loader: 'style-loader!css-loader'
				}
			]
		},
		plugins: [
			new HtmlWebpackPlugin({
				template: './test/index.html',
				filename: 'index.es5.html',
				chunksSortMode: sort
			})
		]
	}
];